## macaulay2 1.24.11+ds

=== CMakeLists.txt ===
###############################################################################
## CMake is a cross-platform system for generating build environments using
## native tools such as Make and Ninja or IDEs such as Xcode and Visual Studio.
##
## See INSTALL-CMake.md for a comprehensive guide to building M2 using CMake.
## Take a look at cmake/configure.cmake for a list of options
## and read cmake/check-libraries.cmake for a list of requirements.
##
## Short instructions:
##  1. cmake -GNinja -S . -B BUILD/cmake
##  2. cmake --build BUILD/cmake --target build-libraries build-programs
##  2. cmake --build BUILD/cmake --target M2-engine M2-binary M2-core M2-emacs
##  2. cmake --build BUILD/cmake --target install-packages check-packages
##  6. cmake --install BUILD/cmake
###############################################################################

## Requires CMake version 3.24 and is tested with 3.30
cmake_minimum_required(VERSION 3.24...3.30)
cmake_policy(VERSION 3.24)
cmake_policy(SET CMP0096 NEW) # preserve leading zeros in version number

## Use the C++20 standard
set(CMAKE_CXX_STANDARD 17)
## Use the C11 (C0X) standard
set(CMAKE_C_STANDARD 11)

###############################################################################
## Set the default build configuration
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Debug)
endif()

## Guard against in-source builds
if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
  message(FATAL_ERROR "In-source builds are not allowed. Delete CMakeFiles and CMakeCache.txt from the source directory.")
endif()
if(EXISTS ${CMAKE_SOURCE_DIR}/include/M2/config.h)
  message(FATAL_ERROR "In-source build artifacts detected. Run `make clean distclean` from the source directory.")
endif()

## Enable support for folders in IDEs
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

## Enable ccache or distcc acceleration with Makefile and Ninja
# Note: libraries and programs aren't using ccache this way.
find_program(CCACHE ccache)
if(CCACHE)
  # run ccache -s to get the CCache statistics
  set(CMAKE_C_COMPILER_LAUNCHER "${CCACHE}")
  set(CMAKE_CXX_COMPILER_LAUNCHER "${CCACHE}")
endif()

###############################################################################
## Source of truth for project version
file(STRINGS VERSION VERSION)

## Set the project name, version, and languages
project(Macaulay2
  VERSION	${VERSION}
  DESCRIPTION	"A software system for algebraic geometry research"
  HOMEPAGE_URL	http://macaulay2.com # contact: Macaulay2@math.uiuc.edu
  LANGUAGES	C CXX)

###############################################################################
## Set path for CMake modules
set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})
include(prechecks) ## CMake macros for preprocessor checks and linting
include(CTest)     ## CMake module for generating a 'test' target for all unit-tests
include(profiling) ## CMake macros for profiling Macaulay2 code
include(configure) ## CMake script for configuring various variables
include(check-libraries) ## CMake script for checking which libraries exist and which need to be built
include(build-libraries) ## CMake script for downloading, building, and installing external libraries
include(startup) ## CMake script for messy substitutions in Macaulay2/bin/startup.c

###############################################################################
## Configure M2/config.h
configure_file(include/M2/config.h.cmake include/M2/config.h)

###############################################################################
## Kick off the Macaulay2 directory
add_subdirectory(Macaulay2)

###############################################################################

include(packaging) ## CMake script for making distribution packages for Macaulay2

###############################################################################
## This section is temporary hacks! Try to reduce or move them elsewhere.

set(M2_CONTENT "#!/bin/sh\nexec ${M2_DIST_PREFIX}/${M2_INSTALL_BINDIR}/M2 \"$@\"")
execute_process(
  COMMAND ${CMAKE_COMMAND} -E echo "${M2_CONTENT}"
  OUTPUT_FILE ${CMAKE_BINARY_DIR}/M2)
execute_process(
  COMMAND chmod +x ${CMAKE_BINARY_DIR}/M2)

# Hackish way to set topSrcdir in startup.m2
# FIXME: DELETING THIS CAUSES CONFUSING PATH ERRORS!!!
file(RELATIVE_PATH LIST_FILE ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_LIST_FILE})
get_filename_component(RELATIVE_SOURCE_DIR ${LIST_FILE} DIRECTORY)
file(GENERATE OUTPUT srcdir CONTENT "${RELATIVE_SOURCE_DIR}/\n")

=== BUILD/frank/Makefile ===
.PHONY: always
always:

BRANCH := $(shell git branch --contains | grep '^\* ' | sed -e s=^..== -e s=/=.=g )

#######################
## cmake build files ##
#######################

cmake-make-appleclang:
	echo "git branch is " $(BRANCH)
	mkdir -p builds.tmp/cmake-make-appleclang-$(BRANCH)
	cd builds.tmp/cmake-make-appleclang-$(BRANCH); cmake \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DCMAKE_INSTALL_PREFIX=`pwd`/installed \
		-DBUILD_TESTING=on \
		-DBUILD_DOCS=on \
		../../../..

cmake-appleclang:
	echo "git branch is " $(BRANCH)
	mkdir -p builds.tmp/cmake-appleclang
	cd builds.tmp/cmake-appleclang; cmake \
		-GNinja \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DBUILD_TESTING=on \
		-DCMAKE_PREFIX_PATH="`brew --prefix libffi`" \
		-DBUILD_DOCS=on \
		-DBUILD_NATIVE=off \
		../../../..

cmake-clang:
	echo "git branch is " $(BRANCH)
	mkdir -p builds.tmp/cmake-clang
	cd builds.tmp/cmake-clang; CC=/opt/homebrew/opt/llvm/bin/clang CXX=/opt/homebrew/opt/llvm/bin/clang++ cmake \
		-GNinja \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DBUILD_TESTING=on \
		-DCMAKE_PREFIX_PATH="`brew --prefix libffi`" \
		-DBUILD_DOCS=on \
		-DBUILD_NATIVE=off \
		../../../..

cmake-appleclang-notbb:
	echo "git branch is " $(BRANCH)
	mkdir -p builds.tmp/cmake-appleclang-notbb
	cd builds.tmp/cmake-appleclang-notbb; cmake \
		-GNinja \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DBUILD_TESTING=on \
		-DCMAKE_PREFIX_PATH="`brew --prefix libffi`" \
		-DBUILD_DOCS=on \
		-DBUILD_NATIVE=off \
		-DWITH_TBB=off \
		../../../..

cmake-debug-appleclang:
	mkdir -p builds.tmp/cmake-debug-appleclang
	cd builds.tmp/cmake-debug-appleclang; cmake \
		-GNinja \
		-DCMAKE_BUILD_TYPE=Debug \
		-DBUILD_TESTING=on \
		-DBUILD_DOCS=on \
		../../../..

cmake-latestclang:
	mkdir -p builds.tmp/cmake-latestclang
	cd builds.tmp/cmake-latestclang; LIBRARY_PATH=`/usr/local/opt/llvm/bin/llvm-config --libdir` cmake \
		-GNinja \
	        -DCMAKE_C_COMPILER:FILEPATH=/usr/local/opt/llvm/bin/clang \
		-DCMAKE_CXX_COMPILER:FILEPATH=/usr/local/opt/llvm/bin/clang++ \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DBUILD_TESTING=on \
		-DBUILD_DOCS=on \
		../../../..

cmake-debug-latestclang:
	mkdir -p builds.tmp/cmake-debug-latestclang
	cd builds.tmp/cmake-debug-latestclang; cmake \
		-GNinja \
	    -DCMAKE_C_COMPILER:FILEPATH=/usr/local/opt/llvm/bin/clang \
		-DCMAKE_CXX_COMPILER:FILEPATH=/usr/local/opt/llvm/bin/clang++ \
		-DCMAKE_BUILD_TYPE=Debug \
		-DBUILD_TESTING=on \
		-DBUILD_DOCS=on \
		../../../..

cmake-gcc9:
	mkdir -p builds.tmp/cmake-gcc9
	cd builds.tmp/cmake-gcc9; cmake \
		-GNinja \
	    -DCMAKE_C_COMPILER:FILEPATH=/usr/local/bin/gcc-9 \
		-DCMAKE_CXX_COMPILER:FILEPATH=/usr/local/bin/g++-9 \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DBUILD_TESTING=on \
		-DBUILD_DOCS=on \
		../../../..
# running cmake-gcc9 now: 30 May 2020.
#  build-libraries (with testing off): 22m36s
#  build-programs (with testing off): 12m19s
#  cmake -DBUILD_TESTING=on .
#  M2-core: 2m51s
#  install-packages: (running)
#  M2-unit-tests
#  check-packages
# ctest

cmake-debug-gcc9:
	mkdir -p builds.tmp/cmake-debug-gcc9
	cd builds.tmp/cmake-debug-gcc9; cmake \
		-GNinja \
	    -DCMAKE_C_COMPILER:FILEPATH=/usr/local/bin/gcc-9 \
		-DCMAKE_CXX_COMPILER:FILEPATH=/usr/local/bin/g++-9 \
		-DCMAKE_BUILD_TYPE=Debug \
		-DBUILD_TESTING=on \
		-DBUILD_DOCS=on \
		../../../..

xcode:
	mkdir -p builds.tmp/xcode
	cd builds.tmp/xcode; cmake \
		-GXcode \
		../../../..

###########################
## configure build files ##
###########################

###########
## MacOS ##
###########
# Some possibly useful configure options
# 		--build=x86_64-apple-darwin
#       --enable-build-libraries="flint ntl"

arm64-no-tbb-appleclang : always
	mkdir -p builds.tmp/arm64-no-tbb-appleclang
	cd builds.tmp/arm64-no-tbb-appleclang; ../../../../configure \
		CPPFLAGS="-I`brew --prefix`/include" \
		LDFLAGS="-L`brew --prefix`/lib" \
		--disable-tbb \
	        --with-boost-regex=boost_regex \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download

darwin64-appleclang : always
	mkdir -p builds.tmp/darwin64-appleclang
	cd builds.tmp/darwin64-appleclang; ../../../../configure \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download

darwin64-latestclang : always
	mkdir -p builds.tmp/darwin64-latestclang
	cd builds.tmp/darwin64-latestclang; ../../../../configure \
		CC="/usr/local/opt/llvm/bin/clang" \
		CXX="/usr/local/opt/llvm/bin/clang++" \
		LDFLAGS="-L/usr/local/opt/llvm/lib -Wl,-rpath,/usr/local/opt/llvm/lib" \
		CPPFLAGS="-I/usr/local/opt/llvm/include" \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download

darwin64-gcc9 : always
	mkdir -p builds.tmp/darwin64-gcc9
	cd builds.tmp/darwin64-gcc9; ../../../../configure \
		CC=gcc-9 CXX=g++-9 \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download

debug64-latestclang : always
	mkdir -p builds.tmp/debug64-latestclang
	cd builds.tmp/debug64-latestclang; ../../../../configure \
		CC="/usr/local/opt/llvm/bin/clang" \
		CXX="/usr/local/opt/llvm/bin/clang++" \
		LDFLAGS="-L/usr/local/opt/llvm/lib -Wl,-rpath,/usr/local/opt/llvm/lib" \
		CPPFLAGS="-I/usr/local/opt/llvm/include" \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download \
		--enable-debug \
		--disable-optimize

debug64-appleclang : always
	mkdir -p builds.tmp/debug64-appleclang
	cd builds.tmp/debug64-appleclang; ../../../../configure \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download \
		--enable-debug \
		--disable-optimize

debug64-gcc9 : always
	mkdir -p builds.tmp/debug64-gcc9
	cd builds.tmp/debug64-gcc9; ../../../../configure \
		CC=gcc-9 CXX=g++-9 \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download \
		--enable-debug \
		--disable-optimize

profile64-latestclang : always
	mkdir -p builds.tmp/profile64-latestclang
	cd builds.tmp/profile64-latestclang; ../../../../configure \
		CC="/usr/local/opt/llvm/bin/clang" \
		CXX="/usr/local/opt/llvm/bin/clang++" \
		LDFLAGS="-L/usr/local/opt/llvm/lib -Wl,-rpath,/usr/local/opt/llvm/lib" \
		CPPFLAGS="-I/usr/local/opt/llvm/include" \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download \
		--enable-profile

profile64-appleclang : always
	mkdir -p builds.tmp/profile64-appleclang
	cd builds.tmp/profile64-appleclang; ../../../../configure \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download \
		--enable-profile

profile64-gcc9 : always
	mkdir -p builds.tmp/profile64-gcc9
	cd builds.tmp/profile64-gcc9; ../../../../configure \
		CC=gcc-9 CXX=g++-9 \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download \
		--enable-profile

###################
## linux ##########
###################

linux-opt64-gcc8 : always
	mkdir -p builds.tmp/opt64-gcc8
	cd builds.tmp/opt64-gcc8; ../../../../configure \
		CC=gcc-8 CXX=g++-8 \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download

linux-opt64 : always
	mkdir -p builds.tmp/opt64
	cd builds.tmp/opt64; ../../../../configure \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download

linux-debug64 : always
	mkdir -p builds.tmp/debug64
	cd builds.tmp/debug64; ../../../../configure \
		--prefix="`pwd`/installed" \
		CPPFLAGS="-DENGINE_DEBUG_" \
		CXXFLAGS=" -U__GNUC_STDC_INLINE__" \
		--enable-debug \
		--disable-optimize \
		--enable-download

linux-profile64 : always
	mkdir -p builds.tmp/profile64
	cd builds.tmp/profile64; ../../../../configure \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-profile \
		--enable-download

######## below this line is older ######################
opt : always
	mkdir -p opt
	cd opt; ../../../configure \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download

debug : always
	mkdir -p debug
	cd debug; ../../../configure \
		--prefix="`pwd`/installed" \
		--enable-debug \
		--disable-strip \
		--disable-optimize \
		--enable-download

profile : always
	mkdir -p profile
	cd profile; ../../../configure \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-profile \
		--enable-download \

# the following is no longer possible for me.
# TODO: work with Dan to fix that.
upload : always
	scp darwin64/*.dmg u00.math.uiuc.edu:/home/html/www/Macaulay2/Uploads

=== Macaulay2/d/CMakeLists.txt ===
###############################################################################
## This directory contains the rules for building M2-interpreter

include(scc) ## CMake macro for calling the Safe C Compiler

# TODO: changing this causes a lot of recompiling
## Configure distributed-packages.h at the destination
string(REPLACE ";" " " DISTRIBUTED_PACKAGES "${DISTRIBUTED_PACKAGES}")
# TODO: configure this header directly in version.dd?
file(GENERATE OUTPUT distributed-packages.h CONTENT "#define DISTRIBUTED_PACKAGES \"${DISTRIBUTED_PACKAGES}\"")

## Configure version.dd at the destination
#configure_file(version.dd.in version.dd #ONLY)

###############################################################################

set(CLIST
  M2types.c M2lib.c M2mem.c types.h
  scclib.c ../c/scc-core.h
  memdebug.c memdebug.h
  debug.c debug.h
  getpagesize.h M2mem.h
  gmp_aux.c gmp_aux.h
  gdbm_interface.c
  )

set(CXXLIST boost-regex.cpp)

# CAUTION: order is important in this list
# TODO: can there be #ifdefs in D sources?
set(DLIST
  arithmetic.d
  atomic.d
  M2.d
  system.d
  strings.d
  varstrin.d
  strings1.d
  errio.d
  vararray.d
  ctype.d
  nets.d
  varnets.d
  interrupts.d
  pthread0.d
  stdiop0.d
  gmp.d
  ballarith.d
  engine.dd
  xml.d		# removed unless WITH_XML
  stdio0.d
  parse.d
  expr.d
  stdio.d
  stdiop.d
  err.d
  gmp1.d
  tokens.d
  getline.d
  lex.d
  parser.d
  binding.d
  basic.d
  common.d
  util.d
  convertr.d
  struct.d
  classes.dd
  buckets.dd
  equality.dd
  hashtables.dd
  regex.dd
  debugging.dd
  evaluate.d
  sets.dd
  mysql.d	# removed unless WITH_SQL
  mysqldummy.d	# removed if WITH_SQL
  pthread.d
  actors.d
  actors2.dd
  actors3.d
  actors4.d
  # tasks.d
  xmlactors.d	# removed unless WITH_XML
  actors5.d
  chrono.dd
  threads.dd
  python.d	# removed unless WITH_PYTHON
  interface.dd interface2.d
  monoid.dd
  monomial_ordering.dd
  texmacs.d
  boostmath.dd
  atomic2.d
  ffi.d		# removed unless WITH_FFI
  interp.dd	# this one is last, because it contains the top level interpreter
  version.dd
  )

# Generator expressions conflict with the macro below, so manually remove the ones we don't need
if(NOT WITH_XML)
  list(REMOVE_ITEM DLIST xml.d xmlactors.d)
endif()
if(NOT WITH_SQL)
  list(REMOVE_ITEM DLIST mysql.d)
else()
  list(REMOVE_ITEM DLIST mysqldummy.d)
endif()
if(NOT WITH_PYTHON)
  list(REMOVE_ITEM DLIST python.d)
endif()
if(NOT WITH_FFI)
  list(REMOVE_ITEM DLIST ffi.d)
endif()

###############################################################################
## Generate TAGS file
# TODO: the order is somewhat different, is it a problem?

if(ETAGS)
  set(TAGS TAGS)
  set_source_files_properties(TAGS PROPERTIES GENERATED true)
  add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/TAGS
    COMMENT "Generating d/TAGS file"
    COMMAND ${ETAGS} -o TAGS ${CLIST} ${CXXLIST} ${DLIST}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
endif()

###############################################################################
## Generate the interpreter

foreach(_d_source IN LISTS DLIST)
  # See cmake/scc.cmake
  _SCC_TRANSLATE(${_d_source} _c) # sets _c_source
  list(APPEND CLIST ${_c_source})
endforeach()

###############################################################################
## Compile the interpreter

# TODO: gmp.d, basic.d, and equality.d require elements from M2-engine
# for that reason, interpreter cannot be compiled as a static library, yet
add_library(M2-interpreter OBJECT ${CLIST} ${CXXLIST} ${TAGS}
  distributed-packages.h
  $<$<BOOL:${WITH_XML}>:xml-c.c xml-c.h>
  $<$<BOOL:${WITH_PYTHON}>:python-c.c>)

target_link_libraries(M2-interpreter PRIVATE M2-supervisor Boost::regex
  $<$<BOOL:${WITH_TBB}>:TBB::tbb>
  $<$<BOOL:${WITH_FFI}>:FFI::ffi>)

# TODO: c.f. https://github.com/Macaulay2/M2/issues/2682
if(NOT APPLE)
  target_link_libraries(M2-interpreter PRIVATE quadmath)
endif()

target_include_directories(M2-interpreter
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/Macaulay2/e> # need newdelete.hpp
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/Macaulay2/c> # need scc-core.h
    $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/Macaulay2/d>
    # for version.dd to get version numbers
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/Macaulay2/e/mathic>
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/Macaulay2/e/memtailor>
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/Macaulay2/e/mathicgb>
    # for libraries that the interpreter needs
    $<BUILD_INTERFACE:${READLINE_INCLUDE_DIR}>
    $<BUILD_INTERFACE:${LIBXML2_INCLUDE_DIR}>
    $<BUILD_INTERFACE:${EIGEN3_INCLUDE_DIR}>
    $<INSTALL_INTERFACE:include/Macaulay2>
    $<$<BOOL:${WITH_PYTHON}>:$<BUILD_INTERFACE:${Python3_INCLUDE_DIRS}>>
  PRIVATE
    # Note: this shouldn't be necessary since FFI::ffi is linked above
    $<$<BOOL:${WITH_FFI}>:$<BUILD_INTERFACE:${FFI_INCLUDE_DIRS}>>
    ${SQLite3_INCLUDE_DIRS}
  )

# TODO: Including most of these is only necessary because of version.dd
# changing or moving that file would allow moving this to e/CMakeLists.txt
foreach(LIB IN LISTS PKGLIB_LIST)
  if(${LIB}_FOUND)
    target_link_libraries(M2-interpreter PUBLIC PkgConfig::${LIB})
  endif()
endforeach()

foreach(LIB IN LISTS LIBRARIES_LIST)
  if(${LIB}_FOUND)
    target_link_libraries(M2-interpreter PUBLIC ${${LIB}_LIBRARIES})
    target_include_directories(M2-interpreter PUBLIC
        "$<BUILD_INTERFACE:${${LIB}_INCLUDE_DIR}>")
  endif()
endforeach()

foreach(LIB IN LISTS LIBRARY_LIST)
  if(${LIB}_FOUND)
    target_link_libraries(M2-interpreter PUBLIC ${${LIB}_LIBRARY})
    target_include_directories(M2-interpreter PUBLIC
        "$<BUILD_INTERFACE:${${LIB}_INCLUDE_DIR}>")
  endif()
endforeach()

# Compiler warning flags
target_compile_options(M2-interpreter PRIVATE
  -Wno-cast-qual # FIXME: caused by M2lib.c:551:43
  -Wno-sign-compare
  -Wno-uninitialized
  -Wno-unused
  -Wno-array-bounds   # FIXME: caused by scc1's implementation of arrays

  # FIXME: mismatched-tags and parentheses-equality errors are caused by scc1
  $<$<COMPILE_LANG_AND_ID:C,AppleClang,Clang>:-Wno-parentheses-equality>
  $<$<COMPILE_LANG_AND_ID:CXX,AppleClang,Clang>:-Wno-mismatched-tags -Wno-parentheses-equality>
  # FIXME: caused by SIMD macro redefinition in fflas_ffpack
  $<$<COMPILE_LANG_AND_ID:CXX,AppleClang,Clang>:-Wno-macro-redefined>

  # FIXME: __builtin_frame_address M2lib.c:165 causes this:
  $<$<COMPILE_LANG_AND_ID:C,GNU>:-Wno-frame-address>
  # Givaro and fflas_ffpack cause these:
  $<$<COMPILE_LANG_AND_ID:CXX,GNU>:-Wno-deprecated-copy -Wno-unknown-pragmas>
  )
# add other compilers (eg: Intel, MSVC) here
# for Intel: -diag-disable 981,869,383,2259,444 -debug

###############################################################################
## Export the target

install(TARGETS M2-interpreter EXPORT Macaulay2 COMPONENT devel EXCLUDE_FROM_ALL)

=== Macaulay2/e/CMakeLists.txt ===
###############################################################################
## This directory contains the rules for building M2-engine and M2-unit-tests
## memtailor, mathic, and mathicgb are also imported as subdirectories here
## - run unit tests:  ctest -R unit-tests (includes mathicgb and friends)

set(with_tbb ${WITH_TBB}) # for mathicgb

add_subdirectory(memtailor)
add_subdirectory(mathic)
add_subdirectory(mathicgb)

target_compile_options(mathicgb PRIVATE
  -Wall -Wextra -Wno-unused-parameter -Wno-unused-value -Wno-unused-variable -Wno-sign-compare
  -Wno-deprecated-declarations
  )

if(CMAKE_BUILD_TYPE MATCHES "Debug") # Debugging
  add_compile_definitions(MEMT_DEBUG MATHIC_DEBUG MATHICGB_DEBUG)
endif()

###############################################################################
## M2-engine sources

# TODO: determine the fate of these files
set(UNDETERMINED
  dmat-ffpack.cpp
  franzi-brp-test.cpp
  overflow-test.cpp
  test.dd
  aring-wrap # both cpp and hpp
  points # both cpp and hpp
  )

# c files
# TODO: convert to cpp or simplify if not needed
# MES TODO:   monordering.c removed this, is that correct?
set(CFILES
  complex.c
  error.c
  exptable.c
  table.c
  )
# h files
set(HFILES
  complex.h
  error.h
  exptable.h
  table.h
  engine.h
  defgroups.h
  mpreal.h
  )

# these files are include only.
set(HPPONLYFILES
  MemoryBlock.hpp
  NCAlgebras/Range.hpp
  VectorArithmetic.hpp
  timing.hpp
  SLP-defs.hpp
  SLP-imp.hpp
  aring-glue.hpp
  aring-qq.hpp
  aring-translate.hpp
  dmat-gf-flint-big.hpp
  dmat-gf-flint.hpp
  dmat-lu-inplace.hpp
  dmat-lu-qq.hpp
  dmat-lu-zzp-ffpack.hpp
  dmat-lu-zzp-flint.hpp
  dmat-lu.hpp
  dmat-qq-flint.hpp
  dmat-qq-interface-flint.hpp
  dmat-zz-flint.hpp
  dmat-zzp-flint.hpp
  engine-includes.hpp
  exceptions.hpp
  geobucket.hpp
  geopoly.hpp
  geovec.hpp
  hash.hpp
  mat-arith.hpp
  mat-elem-ops.hpp
  mat-linalg.hpp
  mat-util.hpp
  mutablemat-defs.hpp
  mutablemat-imp.hpp
  mutablemat.hpp
  newdelete.hpp
  ExponentVector.hpp
  res-a0-pair.hpp
  schur-poly-heap.hpp
  smat.hpp
  util.hpp
  style.hpp
  f4/f4-types.hpp
  f4/memblock.hpp
  f4/ntuple-monomial.hpp
  f4/varpower-monomial.hpp
  gb-f4/MonomialTypes.hpp
  PolynomialStream.hpp
  schreyer-resolution/res-memblock.hpp
  schreyer-resolution/res-monomial-types.hpp
  schreyer-resolution/res-schreyer-order.hpp
  )

# these files have .cpp file, but NOT .hpp file
set(CPPONLYFILES
  engine.cpp # TODO: find a new home for the contents
  franzi-gb.cpp
  franzi-interface.cpp
  matrix-kbasis.cpp
  matrix-sort.cpp
  matrix-symm.cpp
  ntl-debugio.cpp
  ntl-internal.cpp
  res-a2-gb.cpp
  ring-vecs.cpp
  interface/aring.cpp
  interface/aring.h
  interface/computation.h # no .cpp yet
  interface/cra.cpp
  interface/cra.h
  interface/cone.cpp
  interface/cone.h
  interface/factory.cpp
  interface/factory.h
  interface/flint.cpp
  interface/flint.h
  interface/freemodule.cpp # TODO: .h
  interface/gmp-util.h # only has inline definitions
  interface/groebner.cpp
  interface/groebner.h
  interface/matrix.cpp
  interface/matrix.h
  interface/monoid.cpp
  interface/monoid.h
  interface/monomial-ideal.cpp
  interface/monomial-ideal.h
  interface/monomial-ordering.cpp
  interface/monomial-ordering.h
  interface/mutable-matrix.cpp
  interface/mutable-matrix.h
  interface/polyroots.cpp # the declarations are in factory.h
  interface/random.cpp
  interface/random.h
  interface/ring.cpp
  interface/ring.h
  interface/ringelement.cpp
  interface/ringelement.h
  interface/ringmap.cpp
  interface/ringmap.h
  )

# these files all have .hpp and .cpp files
# MES TODO: put these NCAlgebra files (and friends) into alpha order in list
set(SRCLIST
  BasicPoly
  BasicPolyList
  BasicPolyListParser
  myalloc
  matrix-ncbasis
  M2FreeAlgebraQuotient
  M2FreeAlgebra
  NCAlgebras/Word
  NCAlgebras/NCReduction
  NCAlgebras/FreeAlgebraQuotient
  NCAlgebras/FreeAlgebra
  NCAlgebras/FreeMonoid
  NCAlgebras/WordTable
  NCAlgebras/SuffixTree
  NCAlgebras/NCGroebner
  NCAlgebras/NCF4
  NCAlgebras/OverlapTable
  NCResolutions/nc-res-computation
  Polynomial
  monomial-collection
  Eschreyer
  GF
  LLL
  NAG # TODO: move raw* functions to e/interface
  SLP
  ZZ
  ZZp
  aring-RRi
  aring-CC
  aring-CCC
  aring-RR
  aring-RRR
  aring-gf-flint-big
  aring-gf-flint
  aring-m2-gf
  aring-qq-flint
  aring-qq-gmp
  aring-tower
  aring-zz-flint
  aring-zz-gmp
  aring-zzp-ffpack
  aring-zzp-flint
  aring-zzp
  aring
  assprime
  betti
  buffer
  coeffrings
  comb
  comp-gb-declared
  comp-gb-proxy
  comp-gb
  comp-res
  comp
  cra
  debug
  det
  dmat
  dpoly
  eigen
  finalize
  fplll-interface
  frac
  fractionfreeLU
  franzi-brp
  freemod
  gauss
  gb-default
  gb-homog2
  gb-sugarless
  gb-toric
  gb-walk
  gbring
  gbweight
  hermite
  hilb
  imonorder
  int-bag
  interreduce
  interrupted
  lapack
  localring
  mat
  matrix-con
  matrix-stream
  matrix
  mem
  memory-status
  monideal-minprimes
  monideal
  monoid
  monomial-sets
  monomial
  monsort
  montable
  montableZZ
  mutablecomplex
  ntl-interface
  overflow
  pfaff
  poly
  polyquotient
  polyring
  qring
  reader
  reducedgb-ZZ
  reducedgb-field-local
  reducedgb-field
  reducedgb-marked
  reducedgb
  relem
  res-a0-poly
  res-a0
  res-a1-poly
  res-a1
  res-a2
  ring
  ringelem
  ringmap
  sagbi
  schorder
  schur
  schur2
  schurSn
  skew
  skewpoly
  solvable
  spair
  text-io
  tower # TODO: move rawTowerTranslatePoly to e/interface
  ExponentList
  weylalg
  # Faugère's F4 Algorithm
  gb-f4/Basis
  gb-f4/GBF4Computation
  gb-f4/GBF4Interface
  gb-f4/MacaulayMatrix
  gb-f4/MonomialHashTable
  gb-f4/MonomialLookupTable
  gb-f4/MonomialView
  gb-f4/PolynomialList
  gb-f4/SPairs
  f4/f4-computation
  f4/f4-m2-interface
  f4/f4-mem
  f4/f4-monlookup
  f4/f4-spairs
  f4/f4
  f4/hilb-fcn
  f4/monhashtable
  f4/moninfo
  # Schreyer resolution a la Linear algebra (F4 Faugere style)
  schreyer-resolution/res-f4-computation
  schreyer-resolution/res-f4-m2-interface
  schreyer-resolution/res-f4-monlookup
  schreyer-resolution/res-f4
  schreyer-resolution/res-moninfo-dense
  schreyer-resolution/res-moninfo-sparse
  schreyer-resolution/res-moninfo
  schreyer-resolution/res-monomial-sorter
  schreyer-resolution/res-poly-ring
  schreyer-resolution/res-schreyer-frame
  schreyer-resolution/res-dep-graph
  # Boolean Involutive Gröbner Bases
  bibasis/bibasis
  bibasis/allocator
  bibasis/launcher
  bibasis/monom
  bibasis/monomDL
  bibasis/monomDRL
  bibasis/monomLex
  bibasis/settings-manager
  )

list(TRANSFORM SRCLIST APPEND .cpp OUTPUT_VARIABLE CPPFILES)
list(TRANSFORM SRCLIST APPEND .hpp OUTPUT_VARIABLE HPPFILES)

set(SOURCES ${CPPONLYFILES} ${CPPFILES} ${CFILES})
set(HEADERS ${HPPONLYFILES} ${HPPFILES} ${HFILES})
list(APPEND HEADERS ${CMAKE_BINARY_DIR}/include/M2/config.h)

###############################################################################
## Generate TAGS file
# TODO: the order is somewhat different, is it a problem?

if(ETAGS)
  set(TAGS TAGS)
  set_source_files_properties(TAGS PROPERTIES GENERATED true)
  add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/TAGS
    COMMENT "Generating e/TAGS file"
    COMMAND ${ETAGS} -o TAGS ${HEADERS} ${SOURCES}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
endif()

###############################################################################
## Compile the engine
# TODO: enable INTERPROCEDURAL_OPTIMIZATION?

# TODO: remove STATIC once M2-engine can be used independently, then we can
# set -DBUILD_SHARED_LIBS=ON to generate a shared library
add_library(M2-engine STATIC ${SOURCES} ${HEADERS} ${TAGS})

# TODO: Which headers should be included in the development build?
set_target_properties(M2-engine PROPERTIES PUBLIC_HEADER "${HEADERS}")

target_include_directories(M2-engine PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
  $<INSTALL_INTERFACE:include/Macaulay2>)

# TODO: make engine independent of interpreter headers
target_link_libraries(M2-engine PUBLIC M2-interpreter memtailor mathic mathicgb)

if(EIGEN3_FOUND)
  target_link_libraries(M2-engine PUBLIC Eigen3::Eigen)
endif()

if(OpenMP_FOUND)
  target_link_libraries(M2-engine PUBLIC OpenMP::OpenMP_CXX)
endif()

# Compiler warning flags
target_compile_options(M2-engine PRIVATE
  -Wno-cast-qual # FIXME
  -Wno-sign-compare
  -Wno-unused-local-typedefs # FIXME: caused by mathic/Geobucket.h:510:49

  $<$<COMPILE_LANG_AND_ID:CXX,AppleClang,Clang>:
  -Wno-deprecated-register # caused by mps/mpc.h:114:37
  -Wno-mismatched-tags # FIXME: caused by scc1
  -Wno-unused-variable # FIXME: caused by schur2.cpp:597:31
  >

  $<$<COMPILE_LANG_AND_ID:CXX,GNU>:
  -Wno-deprecated-copy #-Wno-unknown-pragmas # caused by Givaro and fflas_ffpack
  -Wno-ignored-qualifiers # FIXME: caused by bibasis/tset.hpp:44:9
  -Wno-implicit-fallthrough # FIXME: caused by gb-default.cpp, gb-walk.cpp, hermite.cpp, etc.
  >

  # Intel TODO: -diag-disable 981,869,383,2259,444 -debug -Wimplicit-function-declaration
  )

###############################################################################
## Export the target

# TODO: change ARCHIVE to LIBRARY once M2-engine can be used independently
install(TARGETS M2-engine mathicgb mathic memtailor EXPORT Macaulay2
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}/Macaulay2/lib
  COMPONENT devel EXCLUDE_FROM_ALL
  PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/Macaulay2
  COMPONENT devel EXCLUDE_FROM_ALL)

###############################################################################
## Add source linting and formatting checks for this target, see cmake/prechecks.cmake

if(LINTING)
  _ADD_PRECHECKS(M2-engine "IWYU" "${CFILES}" "${HPPONLYFILES} ${CPPONLYFILES} ${HPPFILES} ${CPPFILES}")
endif()

_ADD_CLANG_FORMAT(M2-engine "${CFILES}" "${HPPONLYFILES} ${CPPONLYFILES} ${HPPFILES} ${CPPFILES}")

###############################################################################
## To try, run ctest or ./M2-unit-tests in Macaulay2/e

if(BUILD_TESTING)
  include(GoogleTest)

  # TODO: overflow tests
  # TODO: break up into multiple branches
  add_executable(M2-unit-tests
    unit-tests/M2-cpp-replacement.cpp
    unit-tests/M2-replacement.c
    unit-tests/M2mem-replacement.c
    unit-tests/M2mem-replacement.h

    unit-tests/util-polyring-creation.hpp
    unit-tests/util-polyring-creation.cpp
    unit-tests/NewF4Test.cpp
    unit-tests/MonoidTest.cpp
    unit-tests/PolyRingTest.cpp

    unit-tests/ARingTest.hpp
    unit-tests/ARingZZTest.cpp
    unit-tests/ARingZZpTest.cpp
#    unit-tests/ARingGFTest.cpp # FIXME: see aring-gf-givaro.cpp:199
    unit-tests/ARingQQFlintTest.cpp
    unit-tests/ARingQQGmpTest.cpp
    unit-tests/ARingRRTest.cpp
    unit-tests/ARingCCTest.cpp
    unit-tests/ARingRRRTest.cpp
    unit-tests/ARingCCCTest.cpp
    unit-tests/NCGroebnerTest.cpp

    unit-tests/RingTest.hpp
    unit-tests/RingZZTest.cpp
    unit-tests/RingZZpTest.cpp
    unit-tests/RingQQTest.cpp
    unit-tests/RingCCCTest.cpp
    unit-tests/RingRRRTest.cpp
    unit-tests/RingTowerTest.cpp

    unit-tests/DMatTest.hpp
    unit-tests/DMatZZpTest.cpp

    unit-tests/ResTest.cpp
    unit-tests/PointArray.cpp
    unit-tests/SubsetTest.cpp
    unit-tests/basics-test.cpp

    unit-tests/MatrixIOTest.cpp
    unit-tests/fromStream.cpp
    unit-tests/testMain.cpp # not needed, except for GC_INIT
    )

  if(BDWGC_FOUND)
  target_link_libraries(M2-unit-tests M2-engine ${BDWGC_LIBRARIES} ${CMAKE_DL_LIB})
  endif()

  ## Add the tests
  # TODO: valgrind --track-origins=yes ...
  gtest_discover_tests(M2-unit-tests TEST_PREFIX unit-tests:)

  ## Link with Googletest
  if(GTEST_FOUND)
  target_link_libraries(M2-unit-tests GTest::GTest GTest::Main)
  endif()

  target_compile_options(M2-unit-tests PRIVATE
    -Wno-cast-qual # FIXME: caused by NAG.hpp:559:37 and NAG.hpp:603:37
    -Wno-sign-compare
    $<$<COMPILE_LANG_AND_ID:CXX,AppleClang,Clang>:-Wno-mismatched-tags> # FIXME
    )

endif()

=== Macaulay2/m2/CMakeLists.txt ===
###############################################################################
## This directory contains the rules for building M2-core

set(CORE_DIR ${M2_DIST_PREFIX}/${M2_INSTALL_DATADIR}/Core)
set(CORE_TESTS ${M2_DIST_PREFIX}/${M2_INSTALL_DOCDIR}/Core/tests)
set(M2_ARGS -q --silent --stop -e errorDepth=0 --no-preload)

# List of Core sources
file(STRINGS loadsequence M2LIST)

###############################################################################
## Generate TAGS file
# TODO: the TAGS file generated by Makefile has way more sources

if(ETAGS)
  set(TAGS ${CMAKE_CURRENT_SOURCE_DIR}/TAGS)
  set_source_files_properties(TAGS PROPERTIES GENERATED true)
  add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/TAGS
    COMMENT "Generating m2/TAGS file"
    COMMAND ${ETAGS} -o TAGS startup.m2.in Core.m2 ${M2LIST} ${CORE_DIR}/tvalues.m2
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS ${CORE_DIR}/tvalues.m2)
endif()

###############################################################################
## Generate startup.m2, version.m2, and tvalues.m2 and copy the core to usr-dist

## Configure startup.m2
configure_file(startup.m2.in startup.m2 @ONLY)

add_custom_target(M2-core ALL DEPENDS ${CORE_DIR}/tvalues.m2 ${TAGS})

add_custom_command(OUTPUT ${CORE_DIR}/tvalues.m2
  COMMENT "Generating Macaulay2/Core/tvalues.m2"
  COMMAND rm -f ${CORE_DIR}/tvalues.m2     # delete old tvalues.m2
  COMMAND M2-binary ${M2_ARGS} -e "exit 0" # regenerate tvalues.m2
  WORKING_DIRECTORY ${CORE_DIR}
  DEPENDS M2-binary
  VERBATIM)

## Populate GIT_DESCRIPTION and GIT_BRANCH
configure_file(version.m2.in ${M2_DIST_PREFIX}/${M2_INSTALL_DATADIR}/Core/version.m2 @ONLY)

foreach(filename IN LISTS M2LIST ITEMS
    ${CMAKE_CURRENT_BINARY_DIR}/startup.m2 Core.m2 loadsequence)
  file(COPY ${filename} DESTINATION ${CORE_DIR})
endforeach()

## Copy Core tests from Macaulay2/tests/normal to share/doc/Macaulay2/Core/tests
file(COPY ${CMAKE_SOURCE_DIR}/Macaulay2/tests/normal/ DESTINATION ${CORE_TESTS}
  FILES_MATCHING PATTERN "*.m2")

# TODO: handle Style here.

=== Macaulay2/tests/CMakeLists.txt ===
###############################################################################
## This directory contains the rules for adding various tests to CTest.
##
## - list tests:      ctest -N
## - build and test:  ctest --build-and-test
## - rerun matching tests:
##     ctest -R schorder --rerun-failed -V
##
## See https://gitlab.kitware.com/cmake/community/-/wikis/doc/ctest/Testing-With-CTest

# TODO: some targets have different resource limits
set(SUBDIRS normal slow gigantic goals quarantine engine threads)

add_custom_target(M2-tests)
add_dependencies(M2-tests M2-tests-ComputationsBook) # M2-tests-rationality

###############################################################################
## Default resource limits
# TODO: add memory, virtual memory, and stack size
# the tests aren't run through bash, so ulimit wouldn't work
if(DEBUG)
  set(CTEST_TEST_TIMEOUT 1400)
  #MLIMIT ?= 1200000
  #VLIMIT ?= 2000000
else()
  set(CTEST_TEST_TIMEOUT 900)
  ## one test doesn't work with only 150MB RAM, ext-total.m2, on a 64 bit intel machine:
  #MLIMIT ?=  800000
  #VLIMIT ?= 2000000
endif()
## make the stack limit always the same as it would be under MacOS
#SLIMIT ?= 8192

###############################################################################
## M2 arguments and commands that will be passed to M2 -e ${STR}
set(GC_MAXIMUM_HEAP_SIZE 400M CACHE STRING "maximum collected heap size")
set(M2 ${M2_DIST_PREFIX}/${M2_INSTALL_BINDIR}/M2)
# gbTrace, errorDepth, and debugLevel are set in packages/CMakeLists.txt
set(M2_ARGS
  -q --stop --silent --no-debug --no-randomize # --no-prompts --no-...
  -e errorDepth=${errorDepth} -e debugLevel=${debugLevel} -e gbTrace=${gbTrace})
set(M2_PATH "join(path,{\"${CMAKE_CURRENT_SOURCE_DIR}/\",\"${CMAKE_SOURCE_DIR}/packages/\"})")
# Read the file, then exit. Note: a "restart" command causes the test to not halt
set(M2_TEST_TEMPLATE [[input("@CMAKE_CURRENT_SOURCE_DIR@/@_group@/@_testfile@")]])

# Allow GC_MAXIMUM_HEAP_SIZE to be set via environment variable
foreach(_var in ITEMS GC_MAXIMUM_HEAP_SIZE)
  if(DEFINED ENV{${_var}})
    message("## Set via environment:   ${_var}\t= $ENV{${_var$}} (default: ${${_var}})")
    set(${_var} "$ENV{${_var}}")
  endif()
endforeach()

## Regular expressions for various test errors
## TODO: add WILL_FAIL tests
set(M2_FAIL_REGEX
  [[internal error;non-zero status;assertion failed]]
  "--back trace--"
  "\nCommand terminated;\nGC;\n0x;\nout of mem"
  "user.*system.*elapsed;\n[0-9]+\.[0-9]+user"
  [[\.m2:[0-9][0-9]*:[0-9][0-9]*:\([0-9][0-9]*\):]] # TODO: this one catches commented errors
  )

###############################################################################
## Adding tests for all subdirectories

foreach(_group IN LISTS SUBDIRS)

  ## eg: LU.m2 ...
  file(GLOB ${_group}_TESTS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/${_group} "${_group}/*.m2")

  foreach(_testfile IN LISTS ${_group}_TESTS)
    ## ctest target for testing the package
    set(_testname ${_group}/${_testfile})

    ## configure the test string
    string(CONFIGURE "${M2_TEST_TEMPLATE}" M2_TEST_STRING)

    add_test(NAME ${_testname}
      COMMAND ${M2} ${M2_ARGS} -e path=${M2_PATH} -e ${M2_TEST_STRING} -e "exit 0"
      WORKING_DIRECTORY	${CMAKE_CURRENT_SOURCE_DIR}/${_group}
      )

    set_tests_properties(${_testname} PROPERTIES
      FAIL_REGULAR_EXPRESSION "${M2_FAIL_REGEX}"
      ENVIRONMENT "GC_MAXIMUM_HEAP_SIZE=${GC_MAXIMUM_HEAP_SIZE}"
      TIMEOUT ${CTEST_TEST_TIMEOUT} # TODO: this shouldn't be necessary
      )
  endforeach()

endforeach()

###############################################################################
## ComputationsBook targets:
# - M2-tests-ComputationsBook-${_chapter}
# - M2-tests-ComputationsBook-${_chapter}-changes
# - M2-tests-ComputationsBook-${_chapter}-diff
# Tests:
# - ComputationsBook/${_chapter}

add_custom_target(M2-tests-ComputationsBook)

set(CHAPTERS completeIntersections constructions d-modules exterior-algebra geometry
  monomialIdeals preface programming schemes solving toricHilbertScheme varieties)

set(M2_ARGS -q --stop --print-width 0 --silent)

foreach(_chapter IN LISTS CHAPTERS)

  ## configure the test string
  set(_testfile test.m2)
  set(_group ComputationsBook/${_chapter})

  set(book_patterns    ${CMAKE_CURRENT_SOURCE_DIR}/${_group}/../patterns)
  set(chapter_patterns ${CMAKE_CURRENT_SOURCE_DIR}/${_group}/patterns)

  string(CONFIGURE "${M2_TEST_TEMPLATE}" M2_TEST_STRING)
  set(M2_PATH "join({\"${CMAKE_CURRENT_BINARY_DIR}/${_group}\",\"${CMAKE_CURRENT_SOURCE_DIR}/${_group}\"},path)")

  if(NOT EXISTS ${CMAKE_CURRENT_BINARY_DIR}/${_group})
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${_group})
  endif()

  ###############################################################################
  # we depend on "diff" accepting some options that perhaps only GNU diff does
  add_custom_target(M2-tests-ComputationsBook-${_chapter}
    COMMAND ${M2} ${M2_ARGS} -e path=${M2_PATH} -e ${M2_TEST_STRING} -e "exit 0" > test.out 2>&1
    COMMAND sed -f ${book_patterns} -f ${chapter_patterns} > test.out.trim < test.out
    COMMAND sed -f ${book_patterns} -f ${chapter_patterns} > test.out.expected.trim
      < ${CMAKE_CURRENT_SOURCE_DIR}/${_group}/test.out.expected
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${_group}
    VERBATIM
    )
  add_custom_target(M2-tests-ComputationsBook-${_chapter}-diff
    COMMAND diff -B -b -u test.out.expected.trim test.out.trim
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${_group}
    DEPENDS M2-tests-ComputationsBook-${_chapter}
    VERBATIM
    )
  add_custom_target(M2-tests-ComputationsBook-${_chapter}-changes
    COMMAND diff -u chapter.m2 test.m2 || true
    COMMAND diff -u chapter.out.expected test.out.expected || true
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/${_group}
    VERBATIM
    )

  add_dependencies(M2-tests-ComputationsBook M2-tests-ComputationsBook-${_chapter})

  ###############################################################################
  add_test(NAME ${_group}
    COMMAND diff -B -b -u
      ${CMAKE_CURRENT_BINARY_DIR}/${_group}/test.out.expected.trim
      ${CMAKE_CURRENT_BINARY_DIR}/${_group}/test.out.trim
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${_group}
    )

  # TODO: capture output from the chapter's code with M2 version 0.9.2 as a standard of comparison.
  # this requires an old binary, but we run it only once and save the output
  #set(OLDM2 M2-0.9.2)
  #set(OLDM2CMD ${LIMIT} time nice -18 ${OLDM2} -s -q -e${PATHJOIN})
  #add_custom_command(OUTPUT test.oldout test.oldvalues
  #  COMMAND ${OLDM2CMD} -e'load "$(chapter_srcdir)/../capture.m2"; input "$<"; exit 0'  >test.oldout.tmp </dev/null
  #  COMMAND mv test.oldout.tmp test.oldout
  #  DEPENDS chapter.m2 ../capture.m2
  #  )
  #add_custom_target(ComputationsBook-capture
  #  DEPENDS test.oldout test.oldvalues
  #  )

endforeach()

# install normal tests for "check Core"
file(MAKE_DIRECTORY ${M2_DIST_PREFIX}/${M2_INSTALL_DOCDIR}/Core/tests)
file(GLOB CORE_TESTS "${CMAKE_CURRENT_SOURCE_DIR}/normal/*.m2")
foreach(CORE_TEST ${CORE_TESTS})
  file(COPY ${CORE_TEST} DESTINATION ${M2_DIST_PREFIX}/${M2_INSTALL_DOCDIR}/Core/tests/)
endforeach()

# TODO: add_subdirectory(rationality)

=== BUILD/docker/fedora/Makefile ===
include ../ubuntu/Makefile

## Parameters
TAG = m2-fedora-build
BUILD_DIR = M2/BUILD/build-docker
BUILD_OPT = -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/usr

rpm:;       docker run $(VOLUME) -it --entrypoint "" $(TAG) bash -c "cd M2/$(BUILD_DIR); cpack -G RPM"

rpmlint:;   docker run $(VOLUME) -it --entrypoint "" $(TAG) bash -c "rpmlint M2/$(BUILD_DIR)/Macaulay2-*.rpm"

=== BUILD/docker/rhel/Makefile ===
include ../Makefile

## Parameters
DISTRIBUTION = rockylinux
RELEASE = 9
BUILD = autotools
BUILD_ARGS = --build-arg DISTRIBUTION=$(DISTRIBUTION) \
	--build-arg RELEASE=$(RELEASE)
TAG = m2-$(BUILD)-$(DISTRIBUTION)-$(RELEASE)-build
BUILD_DIR = M2/BUILD/build-docker

## Script for building Macaulay2 (autotools)
define M2_BUILD_SCRIPT_autotools
set -xe

git config --global --add safe.directory $(M2_HOME)/M2
mkdir -p M2/$(BUILD_DIR)
cd M2/$(BUILD_DIR)
$(M2_HOME)/M2/M2/autogen.sh
$(M2_HOME)/M2/M2/configure --with-system-gc --enable-download --enable-rpm \
	--prefix=/usr
make
endef
export M2_BUILD_SCRIPT_autotools

###############################################################################
# Build targets

build: build-image
	docker run $(VOLUME) -it --entrypoint="" $(TAG) \
		bash -c "$$M2_BUILD_SCRIPT_$(BUILD)"

=== BUILD/docker/ubuntu/Makefile ===
include ../Makefile

## Parameters
TAG = m2-cmake-build
BUILD_DIR = M2/BUILD/build-docker
BUILD_OPT = -DCMAKE_BUILD_TYPE=Release --debug-trycompile

## Script for building Macaulay2
define M2_BUILD_SCRIPT
set -xe

git config --global user.email "macaulay@docker"
git config --global user.name "Macaulay"

## Full build
cmake -GNinja -S M2/M2 -B M2/$(BUILD_DIR) $(BUILD_OPT)
cmake --build M2/$(BUILD_DIR) --target build-libraries # build-programs
cmake --build M2/$(BUILD_DIR) --target M2-core # install-packages
cmake --build M2/$(BUILD_DIR) --target M2-emacs
## Changes to the docker container after it is created are ephemeral,
## but this is how one would install Macaulay2:
# cmake --install M2/$(BUILD_DIR)
endef
export M2_BUILD_SCRIPT

###############################################################################

build: build-image
	docker run $(VOLUME) -it --entrypoint="" $(TAG) bash -c "$$M2_BUILD_SCRIPT"

# For anything else, run it in the build directory within the container
%:;	docker run $(VOLUME) -it --entrypoint="" $(TAG) cmake --build $(M2_HOME)/M2/$(BUILD_DIR) --target $@

=== Macaulay2/tests/rationality/CMakeLists.txt ===
###############################################################################
# rationality targets and tests

set(M2_ARGS -q --stop)

set(RATIONALITY_TESTS plausibility1.m2 plausibility2.m2 plausibility3.m2 plausibility4.m2 proof-fixed.m2)

set(M2_PATH "join({\"${CMAKE_CURRENT_SOURCE_DIR}/\"},path)")

add_custom_target(M2-tests-rationality)

foreach(_testfile IN LISTS RATIONALITY_TESTS)
  add_custom_target(M2-tests-rationality-${_testfile}
    COMMAND ${M2} ${M2_ARGS} < ${_testfile}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    )

  add_dependencies(M2-tests-rationality M2-tests-rationality-${_testfile})
endforeach()

add_test(NAME rationality/plausibility.m2
  COMMAND sh -c "cat plausibility1.m2 plausibility2.m2 plausibility3.m2 plausibility4.m2 | diff -u plausibility.m2 -"
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )
add_test(NAME rationality/proof.m2
  COMMAND diff -u proof.m2 proof-fixed.m2
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )

=== BUILD/dan/farm/ubuntu32/Makefile ===
# ubuntu32
SSHPORT = 3001
RDPPORT = 3002
VERSION = 10.10
ISO = ubuntu-$(VERSION)-alternate-i386.iso
URL = http://mirror.anl.gov/pub/ubuntu-iso/CDs/$(VERSION)/$(ISO)
include ../Makefile.machine

=== debian/changelog ===
macaulay2 (1.24.11+ds-5) unstable; urgency=medium

  * debian/patches/skip-failing-package-tests.patch
    - Skip several package tests that were failing during continuous
      integration testing.
      + check(85, "Complexes") (fix location, as we were skipping the
        wrong test after the last upload, and also skip on ppc64el, which
        was having the same timing mismatch issue)
      + check(16, "PhylogeneticTrees") (out of memory on i386)

 -- Doug Torrance <dtorrance@debian.org>  Sun, 09 Feb 2025 17:54:37 -0500

macaulay2 (1.24.11+ds-4) unstable; urgency=medium

  * debian/patches/skip-failing-package-tests.patch
    - Skip several package tests that were blocking the gcc-14 migration
      (Closes: #1095290):
      + check(5, "LLLBases") (out of memory on i386)
      + check(15, "PhylogeneticTrees") (out of memory on i386)
      + check(1, "SparseResultants") (out of memory on i386)
      + check(85, "Complexes") (timing mismatch on s390x)

 -- Doug Torrance <dtorrance@debian.org>  Sat, 08 Feb 2025 22:41:44 -0500

macaulay2 (1.24.11+ds-3) unstable; urgency=medium

  * debian/source/options
    - Ignore files generated by autogen.sh.
    - Escape some dots.
    - Sort lines.
  * debian/tests/control
    - Add msolve to Depends for package-tests

 -- Doug Torrance <dtorrance@debian.org>  Sat, 02 Nov 2024 20:49:13 -0400

macaulay2 (1.24.11+ds-2) unstable; urgency=medium

  * debian/copyright
    - Add license info for new NumericalSemigroups package (missed in the
      previous upload).
  * debian/patches/*
    - Refresh patches for new upstream release (some were missed in the
      previous upload).
  * debian/patches/skip-failing-package-tests.patch
    - Skip more failing tests:
      + check(1, "Depth") (fails frequently during autopkgtest)
      + check("Msolve") (all tests on i686)
      + check(11, "SumsOfSquares") (again; not fixed after all)
  * debian/scripts/m2-get-orig-source.sh
    - Run various checks with --merge option even if merge isn't needed.

 -- Doug Torrance <dtorrance@debian.org>  Fri, 01 Nov 2024 21:08:28 -0400

macaulay2 (1.24.11+ds-1) unstable; urgency=medium

  * New upstream release.
  * debian/control
    - Add gfortran to Build-Depends; now needed for detection of BLAS and
      LAPACK.
    - Add libnormaliz-dev to Build-Depends; the Macaulay2 engine now
      requires it.
    - Add libnauty-dev to Build-Depends; needed to properly detect the
      presence of libnormaliz.
    - Add msolve to Build-Depends and Recommends; needed for new Msolve
      package.
    - Remove libjs-underscore from Build-Depends-Indep; no longer used by
      the Visualize package.
  * debian/copyright
    - Remove underscore.js from Files-Excluded; file is no longer present.
    - Update paths and license info for m4 files from Autoconf Archive.
    - Add license info for new packages:
      + AbstractSimplicialComplexes
      + Msolve
      + MultigradedImplicitization
      + Permutations
      + SCMAlgebras
  * debian/examples/*
    - Update hashes for cached examples; hash codes are now 64-bit unsigned
      integers.
  * debian/macaulay2-common.linktrees
    - Remove underscore.js from list of JavaScript libraries to embed.
  * debian/patches/*
    - Refresh patches for new upstream release.
  * debian/patches/libatomic.patch
    - Remove patch; applied upstream.
  * debian/patches/skip-failing-core-tests.patch
    - Skip new test that takes too much memory during builds where we
      haven't built the documentation.
  * debian/patches/skip-failing-package-tests.patch
    - Stop skipping SumsOfSquares package test; issue fixed upstream.
    - Start skipping new tests that occassionally fail:
      + check({2, 3}, "Cremona") (arm only)
      + check(4, "Msolve") (arm & i686 only)
      + check(6, "NumericalImplicitization")
      + check({2, 3}, "ThreadedGB")
  * debian/rules
    - Stop linking against -latomic on certain architectures; this is now
      dealt with by upstream's configure script.
    - Update options to configure script when using "nopython" build
      profile since building with Python support is now the default.
    - Restore creation of dummy KaTeX files since html-check-links
      is working again.
  * debian/scripts/m2-get-orig-source.sh
    - Update versioning scheme to use "git describe" instead of counting
      the number of commits since M2/VERSION was updated.
    - Update patching of git-description.patch to account for changes to
      configure.ac.
  * debian/tests/control
    - Update basic-tests autopkgtest now that the M2 --check option has
      been simplified.

 -- Doug Torrance <dtorrance@debian.org>  Fri, 01 Nov 2024 09:49:14 -0400

macaulay2 (1.24.05+ds-5) unstable; urgency=medium

  * debian/control
    - Add emacs-nox to Build-Depends; need it to determine the version
      number that dh-elpa will use for the Emacs files' installation
      directory during architecture-dependent builds.
  * debian/elpa-macaulay2.*
    - Update path to Emacs files (add "-src").
  * debian/patches/reproducible-version.patch
    - Stop patching the Linux kernel release with a dummy value.
  * debian/patches/use-cached-examples.patch
    - Stop raising errors when example hashes change; can be frustrating
      for package development.
  * debian/patches/use-dh-elpa.patch
    - Use currentLayout#"emacs" for Emacs path in setupEmacs().
  * debian/rules
    - Set TLIMIT to unlimited during Core tests to prevent them from
      timing out.
    - Use Emacs to determine the version number that dh-elpa will use
      when installing the Emacs files.  (In particular, it will strip
      leading 0's.)
    - Specify that the Emacs files will be installed to the elpa-src
      subdirectory.
  * debian/scripts/m2-get-orig-source.sh
    - Exit gracefully if dch is not found.
    - Keep going when M2 errors out.

 -- Doug Torrance <dtorrance@debian.org>  Sun, 08 Sep 2024 20:38:13 -0400

=== debian/control ===
Source: macaulay2
Section: math
Priority: optional
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Doug Torrance <dtorrance@debian.org>
Build-Depends: 4ti2,
               bison,
               cohomcalg,
               coinor-csdp,
               debhelper-compat (= 13),
               dh-linktree,
               emacs-nox,
               fflas-ffpack,
               flex,
               gfan,
               gfortran,
               install-info,
               libboost-dev,
               libboost-math-dev,
               libboost-regex-dev,
               libboost-stacktrace-dev,
               libcdd-dev,
               libeigen3-dev,
               libffi-dev,
               libflint-dev (>= 2.6.0~),
               libfrobby-dev,
               libgc-dev,
               libgdbm-dev,
               libglpk-dev,
               libgtest-dev,
               liblapack-dev,
               liblzma-dev,
               libmathic-dev,
               libmathicgb-dev (>= 1.0~git20220225~),
               libmemtailor-dev,
               libmpfi-dev,
               libmpfr-dev,
               libmps-dev,
               libnauty-dev,
               libnormaliz-dev,
               libntl-dev,
               libreadline-dev,
               libsingular4-dev (>= 1:4.2.0~),
               libtbb-dev,
               libxml2-dev,
               lrslib,
               lsb-release,
               msolve,
               nauty,
               normaliz,
               pkgconf,
               python3-dev <!nopython>,
               r-base,
               singular-data,
               time,
               topcom
Build-Depends-Indep: dh-sequence-elpa,
                     faketime,
                     fonts-glyphicons-halflings,
                     fonts-katex,
                     gdbmtool,
                     jdupes,
                     libjs-bootsidemenu,
                     libjs-bootstrap,
                     libjs-d3,
                     libjs-jquery (>= 3.5.1+dfsg+~3.5.5-4),
                     libjs-katex (>= 0.11.0~),
                     libjs-nouislider,
                     libjs-three,
                     node-clipboard,
                     node-css-loader <!nodoc>,
                     node-import-local <!nodoc>,
                     node-interpret <!nodoc>,
                     node-prismjs <!nodoc>,
                     node-rechoir <!nodoc>,
                     node-style-loader <!nodoc>,
                     npm <!nodoc>,
                     pkg-js-tools <!nodoc>,
                     webpack <!nodoc>
Standards-Version: 4.7.0
Homepage: http://macaulay2.com
Vcs-Browser: https://salsa.debian.org/math-team/macaulay2
Vcs-Git: https://salsa.debian.org/math-team/macaulay2.git
Rules-Requires-Root: no

Package: macaulay2
Architecture: any
Depends: gdbmtool,
         macaulay2-common (= ${source:Version}),
         normaliz,
         singular-data,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: 4ti2,
            cohomcalg,
            coinor-csdp,
            elpa-macaulay2 (= ${source:Version}),
            msolve,
            gfan,
            info,
            lrslib,
            nauty,
            texlive-latex-base,
            topcom,
            www-browser,
            xdg-utils,
            xterm
Suggests: bergman,
          dot2tex,
          fig2dev,
          graphviz,
          pdf-viewer,
          phcpack,
          polymake,
          r-base,
          qepcad,
          sdpa
Description: Software system for algebraic geometry research
 Macaulay 2 is a software system for algebraic geometry research, written by
 Daniel R. Grayson and Michael E. Stillman.  Based on Groebner bases, it
 provides algorithms for computing homological invariants of rings and
 modules.
 .
 This package contains the architecture dependent portion of Macaulay2.

Package: macaulay2-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Software system for algebraic geometry research (common files)
 Macaulay 2 is a software system for algebraic geometry research, written by
 Daniel R. Grayson and Michael E. Stillman.  Based on Groebner bases, it
 provides algorithms for computing homological invariants of rings and
 modules.
 .
 This package contains the architecture independent portion of Macaulay2, and is
 normally installed automatically when one of the architecture dependent
 packages is installed.

Package: elpa-macaulay2
Architecture: all
Multi-Arch: foreign
Section: editors
Depends: ${elpa:Depends}, ${misc:Depends}
Recommends: emacs
Description: Software system for algebraic geometry research (Emacs package)
 Macaulay 2 is a software system for algebraic geometry research, written by
 Daniel R. Grayson and Michael E. Stillman.  Based on Groebner bases, it
 provides algorithms for computing homological invariants of rings and
 modules.
 .
 This package contains the modes for running Macaulay2 within Emacs and
 editing Macaulay2 code.

=== debian/tests/control ===
Test-Command: M2 --check 1
Depends: macaulay2
Restrictions: allow-stderr
Features: test-name=basic-tests

Test-Command: M2 --check 2
Depends: 4ti2, gfan, macaulay2, normaliz
Restrictions: allow-stderr
Features: test-name=core-tests

Test-Command: M2 --check 3
Depends: 4ti2,
         cohomcalg,
         coinor-csdp,
         gfan,
         libmpfi-dev,
         macaulay2,
         msolve,
         nauty,
         normaliz,
         topcom
Restrictions: allow-stderr
Architecture: !armhf
Features: test-name=package-tests

Test-Command: M2 --script debian/tests/check-doc-db.m2
Depends: macaulay2
Features: test-name=database-smoke-test

=== debian/watch ===
version=4
opts=dversionmangle=s/@DEB_EXT@//,repacksuffix=+ds,uversionmangle=s/-rc/~rc/ \
https://github.com/Macaulay2/M2/tags .*/release-@ANY_VERSION@@ARCHIVE_EXT@ \
debian debian/scripts/m2-tarball-warning.sh
